// $Id: exception.h,v 1.8 2003/03/11 19:40:42 gordon Exp $	
//
// Copyright (C) 2002 Gordon Fraser <gordon@debian.org>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// See the COPYING file for more details
//

#ifndef __exception_h__
#define __exception_h__

#include <stdlib.h>
#include <string>
#include <stdio.h>

#include <iostream>

using std::string;

//--------------------------------------------------------------------
class Exception
{
 protected:
  string error_message_;
  
 public:
  Exception();
  Exception(const string&);
  //  Exception(const Exception&);
  virtual ~Exception();
  const string& getErrorMessage() const;

/*   Exception(const Exception& e); */
/*   Exception& operator=(const Exception&); */
};


//--------------------------------------------------------------------
class MixerDeviceException : public Exception
{
 public:
  MixerDeviceException(const string&);
  virtual ~MixerDeviceException();
  //  MixerDeviceException(const MixerDeviceException& e);
};

//--------------------------------------------------------------------
class InvalidChannelException : public Exception
{
 public:
  InvalidChannelException(unsigned);
  InvalidChannelException(const string&);
  virtual ~InvalidChannelException();
};

//--------------------------------------------------------------------
class InvalidThemeException : public Exception
{
 public:
  InvalidThemeException(const string&);
};

//--------------------------------------------------------------------
class InvalidConfigFileException : public Exception
{
 public:
  InvalidConfigFileException(const string&);
};

//--------------------------------------------------------------------
class FileNotFoundException : public Exception
{
 public:
  FileNotFoundException(const string&);
};

#endif //__exception_h__
